;
; 227 bytes by Fluff for FLI-viewer compo on #asm

.model tiny
.386
.code
org 100h
_main:

        mov     bx,80h
        add     bl,ds:[bx]
        mov     ds:[bx+1],bh

        mov     ax,3d00h
        push    ax
        mov     dx,82h
        int     21h
        xchg    ax,bx
        pop     ds

        mov     al,13h
        int     10h

        push    0a000h
        pop     es

beginning:
        mov     ax,4200h
        xor     cx,cx
        cwd
        int     21h

        mov     ah,3fh
        mov     cl,128
        int     21h
        mov     si,ds:[16]
        mov     di,ds:[6]

mainlop:
        pusha
        xor     si,si
        mov     ah,3fh
        mov     cl,16
        cwd
        int     21h
        mov     bp,[si+6]               ; BP = # of chunks
        neg     cx
        add     cx,[si]
        mov     ah,3fh
        int     21h

nextchunk:
        xor     di,di
        mov     ax,[si]
        pusha
        lodsd
        lodsw
        xchg    cx,ax

        sub     cl,11
        jnz     notfli_color
        lodsw
        xchg    cx,ax
flicolorlop:
        mov     dx,3c8h
        add     al,[si]
        out     dx,al
        push    ax
        lodsw
        inc     dx
flicolorlop1:
        outsb
        outsb
        outsb
        dec     ah
        jnz     flicolorlop1
        pop     ax
        loop    flicolorlop

notfli_color:
        loop    notfli_lc
        mov     bx,320
        lodsw
        mul     bx
        xchg    di,ax
        lodsw
        xchg    dx,ax
flilclop:
        push    di
        lodsb
        xchg    cx,ax
        jcxz    flilclopend
flilclop1:
        lodsb
        add     di,ax
        call    gnu
        loop    flilclop1
flilclopend:
        pop     di
        add     di,bx
        dec     dx
        jnz     flilclop

notfli_lc:
                                        ; We can ignore FLI_BLACKs, they can
                                        ; only exist in first frame and are NOT
                                        ; wanted when we loop! The mode-set
                                        ; does the job in the first loop.

notfli_black:
        sub     cl,3
        jnz     notfli_brun
        mov     bx,200
flibrunlop:
        lodsb
        mov     cl,al
flibrunlop1:
        call    gnu
        loop    flibrunlop1
        dec     bx
        jnz     flibrunlop


notfli_brun:
        loop    notfli_copy
        mov     ch,7dh
        rep     movsw

notfli_copy:

chunkdone:
        popa
        add     si,ax
        dec     bp
        jnz     nextchunk

        popa

        mov     cx,si                   ; fix speed
        mov     dx,3dah
s1:
        in      al,dx
        test    al,8
        jnz     s1
s2:
        in      al,dx
        test    al,8
        jz      s2
        loop    s1

        dec     di
        jz      beginning

        mov     ah,1
        int     16h
        jz      mainlop

exit:
        mov     ax,03h
        int     10h

                ; heh... oh well, there's a RET further down here... ;)

;-------------------------------
gnu:
        push    cx
        lodsb
        cbw
        xchg    cx,ax
        or      bh,bh
        jnz     gnu1
        neg     cx
gnu1:
        or      cl,cl
        js      gnus
        rep     movsb
        jmp     gnuend
gnus:
        neg     cx
        lodsb
        rep     stosb
gnuend:
        pop     cx
        ret

;-------------------------------

end _main
